package main

import (
	"fmt"

	"github.com/tencentcloud/tencentcloud-sdk-go/tencentcloud/common"
	"github.com/tencentcloud/tencentcloud-sdk-go/tencentcloud/common/errors"
	"github.com/tencentcloud/tencentcloud-sdk-go/tencentcloud/common/profile"
	tdmq "github.com/tencentcloud/tencentcloud-sdk-go/tencentcloud/tdmq/v20200217"
)

/**
 * 消费消息示例
 */
func main() {
	// 认证信息
	credential := common.NewCredential(
		"AKIDSiiRt87oxxxxxxxo55oH",
		"GGzSeaM5xxxxxxxxx6LIzPYQ2O",
	)
	cpf := profile.NewClientProfile()
	cpf.HttpProfile.Endpoint = "tdmq.tencentcloudapi.com"
	// 创建客户端
	client, _ := tdmq.NewClient(credential, "ap-shanghai", cpf)

	request := tdmq.NewReceiveMessageRequest()
	// 设置topic名称, 格式为:集群（租户）ID/命名空间/Topic名称
	request.Topic = common.StringPtr("pulsar-xxx/go_http/topic1")
	// 设置订阅名称
	request.SubscriptionName = common.StringPtr("sub")
	// consumer接收的消息会首先存储到receiverQueueSize这个队列中，用作调优接收消息的速率
	request.ReceiverQueueSize = common.Int64Ptr(10)
	// 设置consumer初始接收消息的位置，可选参数为：Earliest, Latest
	request.SubInitialPosition = common.StringPtr("Latest")
	// 消费消息
	response, err := client.ReceiveMessage(request)
	if _, ok := err.(*errors.TencentCloudSDKError); ok {
		fmt.Printf("An API error has returned: %s", err)
		return
	}
	if err != nil {
		panic(err)
	}
	fmt.Printf("%s", response.ToJsonString())
}
