package main

import (
	"fmt"

	"github.com/tencentcloud/tencentcloud-sdk-go/tencentcloud/common"
	"github.com/tencentcloud/tencentcloud-sdk-go/tencentcloud/common/errors"
	"github.com/tencentcloud/tencentcloud-sdk-go/tencentcloud/common/profile"
	tdmq "github.com/tencentcloud/tencentcloud-sdk-go/tencentcloud/tdmq/v20200217"
)

/**
 * 删除订阅示例
 */
func main() {
	// 认证信息
	credential := common.NewCredential(
		"AKIDSiiRt87oxxxxxxxo55oH",
		"GGzSeaM5xxxxxxxxx6LIzPYQ2O",
	)
	cpf := profile.NewClientProfile()
	cpf.HttpProfile.Endpoint = "tdmq.tencentcloudapi.com"
	// 创建tdmq客户端
	client, _ := tdmq.NewClient(credential, "ap-shanghai", cpf)

	request := tdmq.NewDeleteSubscriptionsRequest()

	// 设置要删除的订阅信息
	request.SubscriptionTopicSets = []*tdmq.SubscriptionTopic{
		&tdmq.SubscriptionTopic{
			EnvironmentId:    common.StringPtr("go_http"),
			TopicName:        common.StringPtr("topic1"),
			SubscriptionName: common.StringPtr("sub"),
		},
	}
	// 设置集群id
	request.ClusterId = common.StringPtr("pulsar-xxx")
	// 设置命名空间名称
	request.EnvironmentId = common.StringPtr("go_http")
	// 设置强制删除
	request.Force = common.BoolPtr(true)

	// 删除订阅信息
	response, err := client.DeleteSubscriptions(request)
	if _, ok := err.(*errors.TencentCloudSDKError); ok {
		fmt.Printf("An API error has returned: %s", err)
		return
	}
	if err != nil {
		panic(err)
	}
	fmt.Printf("%s", response.ToJsonString())
}
