package main

import (
	"fmt"

	"github.com/tencentcloud/tencentcloud-sdk-go/tencentcloud/common"
	"github.com/tencentcloud/tencentcloud-sdk-go/tencentcloud/common/errors"
	"github.com/tencentcloud/tencentcloud-sdk-go/tencentcloud/common/profile"
	tdmq "github.com/tencentcloud/tencentcloud-sdk-go/tencentcloud/tdmq/v20200217"
)

/**
 * 创建topic示例
 */
func main() {
	// 认证信息
	credential := common.NewCredential(
		"AKIDSiiRt87oxxxxxxxo55oH",
		"GGzSeaM5xxxxxxxxx6LIzPYQ2O",
	)
	cpf := profile.NewClientProfile()
	cpf.HttpProfile.Endpoint = "tdmq.tencentcloudapi.com"
	// 创建tdmq客户端
	client, _ := tdmq.NewClient(credential, "ap-shanghai", cpf)

	request := tdmq.NewCreateTopicRequest()

	// 设置命名空间名称
	request.EnvironmentId = common.StringPtr("go_http")
	// 设置topic名称
	request.TopicName = common.StringPtr("topic1")
	// 设置分区数量
	request.Partitions = common.Uint64Ptr(3)
	// 设置topic说明信息
	request.Remark = common.StringPtr("topic1说明信息")
	// 设置topic类型0： 普通消息； 1 ：全局顺序消息(设置全局顺序是，分区数要为0)； 2 ：局部顺序消息；
	request.TopicType = common.Uint64Ptr(0)
	// 设置集群id
	request.ClusterId = common.StringPtr("pulsar-xxx")

	// 创建topic
	response, err := client.CreateTopic(request)
	if _, ok := err.(*errors.TencentCloudSDKError); ok {
		fmt.Printf("An API error has returned: %s", err)
		return
	}
	if err != nil {
		panic(err)
	}
	fmt.Printf("%s", response.ToJsonString())
}
