package main

import (
	"fmt"

	"github.com/tencentcloud/tencentcloud-sdk-go/tencentcloud/common"
	"github.com/tencentcloud/tencentcloud-sdk-go/tencentcloud/common/errors"
	"github.com/tencentcloud/tencentcloud-sdk-go/tencentcloud/common/profile"
	tdmq "github.com/tencentcloud/tencentcloud-sdk-go/tencentcloud/tdmq/v20200217"
)

/**
 * 删除topic示例
 */
func main() {
	// 认证信息
	credential := common.NewCredential(
		"AKIDSiiRt87oxxxxxxxo55oH",
		"GGzSeaM5xxxxxxxxx6LIzPYQ2O",
	)
	cpf := profile.NewClientProfile()
	cpf.HttpProfile.Endpoint = "tdmq.tencentcloudapi.com"
	// 创建tdmq客户端
	client, _ := tdmq.NewClient(credential, "ap-shanghai", cpf)

	request := tdmq.NewDeleteTopicsRequest()

	// 要删除的topic信息
	request.TopicSets = []*tdmq.TopicRecord{
		&tdmq.TopicRecord{
			EnvironmentId: common.StringPtr("go_http"),
			TopicName:     common.StringPtr("topic1"),
		},
	}

	// 设置集群id
	request.ClusterId = common.StringPtr("pulsar-xxx")
	// 设置命名空间名称
	request.EnvironmentId = common.StringPtr("go_http")
	// 设置强制删除，会把topic的订阅信息一并删除，不设置时，如果存在订阅信息会导致删除失败
	request.Force = common.BoolPtr(true)

	// 删除订阅信息
	response, err := client.DeleteTopics(request)
	if _, ok := err.(*errors.TencentCloudSDKError); ok {
		fmt.Printf("An API error has returned: %s", err)
		return
	}
	if err != nil {
		panic(err)
	}
	fmt.Printf("%s", response.ToJsonString())
}
